"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Button = require("./Button.styled");

var _Button2 = require("./Button.type");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Button';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Button.styles, {
  name: name
});
var Button = React.forwardRef(function (props, ref) {
  var _classNames;

  var _props$as = props.as,
      Component = _props$as === void 0 ? 'button' : _props$as,
      classNameProp = props.className,
      onClick = props.onClick,
      children = props.children,
      _props$variant = props.variant,
      variant = _props$variant === void 0 ? 'standard' : _props$variant,
      disabled = props.disabled,
      _props$size = props.size,
      size = _props$size === void 0 ? 'medium' : _props$size,
      _props$block = props.block,
      block = _props$block === void 0 ? false : _props$block,
      ghost = props.ghost,
      rest = _objectWithoutProperties(props, ["as", "className", "onClick", "children", "variant", "disabled", "size", "block", "ghost"]);

  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, (_classNames = {}, _defineProperty(_classNames, classes.variantStandard, variant === 'standard'), _defineProperty(_classNames, classes.variantPrimary, variant === 'primary'), _defineProperty(_classNames, classes.sizeSmall, size === 'small'), _defineProperty(_classNames, classes.sizeMedium, size === 'medium'), _defineProperty(_classNames, classes.sizeLarge, size === 'large'), _defineProperty(_classNames, classes.block, block), _defineProperty(_classNames, classes.ghost, ghost), _classNames), classNameProp);
  return React.createElement(Component, _extends({
    className: className,
    ref: ref,
    onClick: onClick,
    disabled: disabled
  }, rest), children);
});
Button.displayName = "F".concat(name);
Button.propTypes = _Button2.ButtonPropTypes;
Button.defaultProps = {
  variant: 'standard',
  size: 'medium',
  block: false
};
var _default = Button;
exports["default"] = _default;