import * as React from 'react';
import * as PropTypes from 'prop-types';
import { StandardProps, StyledProps } from '..';
export declare type CheckboxClassProps = 'root' | 'checked' | 'disabled';
export interface CheckboxProps extends StandardProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement, 'onChange'>, StyledProps {
    checked?: boolean;
    value?: string;
    onChange?: (checked: boolean) => void;
    disabled?: boolean;
}
export declare const CheckboxPropTypes: {
    checked: PropTypes.Requireable<boolean>;
    value: PropTypes.Requireable<string>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    disabled: PropTypes.Requireable<boolean>;
};
