"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CommandContext = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _icons = require("@fluent-ui/icons");

var _hooks = require("@fluent-ui/hooks");

var _utils = require("../utils");

var _Box = _interopRequireDefault(require("../Box"));

var _Command = require("./Command.styled");

var _Secondary = _interopRequireDefault(require("./components/Secondary"));

var _Content = _interopRequireDefault(require("./components/Content"));

var _Portal = _interopRequireDefault(require("../Portal"));

var _Item = _interopRequireDefault(require("../Item"));

var _Transition = _interopRequireDefault(require("../Transition"));

var _Command2 = require("./Command.type");

var _reactJss = require("react-jss");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Command';
exports.name = name;
var useStyles = (0, _reactJss.createUseStyles)(_Command.styles, {
  name: name
});
var CommandContext = React.createContext(false);
exports.CommandContext = CommandContext;
var Command = React.forwardRef(function (props, ref) {
  var _props$as = props.as,
      as = _props$as === void 0 ? 'div' : _props$as,
      classNameProp = props.className,
      _props$acrylic = props.acrylic,
      acrylic = _props$acrylic === void 0 ? false : _props$acrylic,
      _props$reveal = props.reveal,
      reveal = _props$reveal === void 0 ? false : _props$reveal,
      children = props.children,
      rest = _objectWithoutProperties(props, ["as", "className", "acrylic", "reveal", "children"]);

  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, classNameProp);
  var container = {
    content: [],
    standard: [],
    secondary: null
  };
  React.Children.forEach(children, function (child) {
    if (child.type.displayName === 'FCommandContent') {
      container.content.push(child);
    } else if (child.type.displayName === 'FCommandSecondary') {
      container.secondary = child.props.children;
    } else {
      container.standard.push(child);
    }
  }); // Reveal does not take effect when using acrylic

  var _reveal = acrylic ? false : reveal;

  var _useReveal = (0, _hooks.useReveal)(),
      _useReveal2 = _slicedToArray(_useReveal, 1),
      RevealWrapper = _useReveal2[0]; // Secondary Popup related


  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      secondaryVisible = _React$useState2[0],
      setSecondaryVisible = _React$useState2[1];

  function handleSecondaryVisible() {
    if (secondaryVisible) return;
    setSecondaryVisible(function (visible) {
      return !visible;
    });
  } // Click on the area outside the More menu to close the More menu.


  var _usePopper = (0, _hooks.usePopper)({
    placement: 'bottom'
  }),
      _usePopper2 = _slicedToArray(_usePopper, 2),
      referenceRef = _usePopper2[0],
      popperRef = _usePopper2[1];

  (0, _hooks.useClickOutside)(popperRef, function (event) {
    // @ts-ignore
    if (!referenceRef.current || referenceRef.current.contains(event.target)) return;
    setSecondaryVisible(function (visible) {
      return !visible;
    });
  });
  var otherProps = (0, _utils.omit)(rest, ['display', 'backgroundColor', 'color']);
  return React.createElement(_Box["default"], _extends({
    ref: ref,
    as: as,
    acrylic: acrylic,
    className: className,
    backgroundColor: "standard.light2"
  }, otherProps), React.createElement(CommandContext.Provider, {
    value: _reveal
  }, !!container.content.length && React.createElement("div", {
    className: classes.content
  }, container.content), React.createElement("div", {
    className: classes.primary
  }, _reveal ? container.standard.map(function (child, i) {
    return React.createElement(RevealWrapper, {
      key: i
    }, child);
  }) : container.standard), container.secondary !== null && (_reveal ? React.createElement(RevealWrapper, null, React.createElement(_Item["default"], {
    ref: referenceRef,
    style: {
      height: '100%'
    },
    onClick: handleSecondaryVisible,
    prefix: React.createElement(_icons.MoreLine, null)
  })) : React.createElement(_Item["default"], {
    ref: referenceRef,
    onClick: handleSecondaryVisible,
    prefix: React.createElement(_icons.MoreLine, null)
  })), React.createElement(_Portal["default"], null, React.createElement(_Transition["default"], {
    visible: secondaryVisible,
    wrapper: true,
    mountOnEnter: true,
    unmountOnExit: true
  }, React.createElement(_Box["default"], {
    ref: popperRef,
    acrylic: acrylic,
    backgroundColor: "standard.light2",
    className: classes.secondaryRoot
  }, container.secondary)))));
});
Object.defineProperty(Command, 'Secondary', {
  get: function get() {
    return _Secondary["default"];
  }
});
Object.defineProperty(Command, 'Content', {
  get: function get() {
    return _Content["default"];
  }
});
Command.displayName = "F".concat(name);
Command.propTypes = _Command2.CommandPropTypes;
var _default = Command;
exports["default"] = _default;