"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.DialogContext = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Dialog = require("./Dialog.styled");

var _Box = _interopRequireDefault(require("../Box"));

var _Portal = _interopRequireDefault(require("../Portal"));

var _Transition = _interopRequireDefault(require("../Transition"));

var _Title = _interopRequireDefault(require("./components/Title"));

var _Content = _interopRequireDefault(require("./components/Content"));

var _Actions = _interopRequireDefault(require("./components/Actions"));

var _Dialog2 = require("./Dialog.type");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Dialog';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Dialog.styles, {
  name: name
});
var DialogContext = React.createContext({
  onChange: function onChange() {}
});
exports.DialogContext = DialogContext;
var Dialog = React.forwardRef(function (props, ref) {
  var _props$as = props.as,
      as = _props$as === void 0 ? 'div' : _props$as,
      classNameProp = props.className,
      children = props.children,
      visible = props.visible,
      onChange = props.onChange,
      rest = _objectWithoutProperties(props, ["as", "className", "children", "visible", "onChange"]);

  function handleClose() {
    onChange && onChange(false);
  }

  var container = {
    title: undefined,
    content: [],
    actions: undefined
  };
  React.Children.forEach(children, function (child) {
    if (child.type.displayName === "F".concat(name, "Title")) {
      container.title = child;
    } else if (child.type.displayName === "F".concat(name, "Actions")) {
      container.actions = child;
    } else {
      container.content.push(child);
    }
  });
  var contextValue = {
    onChange: onChange
  };
  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, classNameProp);
  return React.createElement(React.Fragment, null, React.createElement(_Portal["default"], null, React.createElement(_Transition["default"], {
    visible: visible,
    wrapper: false,
    mountOnEnter: true,
    unmountOnExit: true
  }, React.createElement("div", {
    className: classes.mask,
    onClick: handleClose
  }))), React.createElement(_Portal["default"], null, React.createElement(_Transition["default"], {
    visible: visible,
    wrapper: false,
    mountOnEnter: true,
    unmountOnExit: true
  }, React.createElement(_Box["default"], _extends({
    className: className,
    ref: ref,
    as: as,
    boxShadow: "5"
  }, rest), React.createElement(DialogContext.Provider, {
    value: contextValue
  }, !!container.title && container.title, React.createElement("div", {
    className: classes.content
  }, container.content), !!container.actions && container.actions)))));
});
Object.defineProperty(Dialog, 'Title', {
  get: function get() {
    return _Title["default"];
  }
});
Object.defineProperty(Dialog, 'Content', {
  get: function get() {
    return _Content["default"];
  }
});
Object.defineProperty(Dialog, 'Actions', {
  get: function get() {
    return _Actions["default"];
  }
});
Dialog.displayName = "F".concat(name);
Dialog.propTypes = _Dialog2.DialogPropTypes;
var _default = Dialog;
exports["default"] = _default;