"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var PropTypes = _interopRequireWildcard(require("prop-types"));

var _styles = require("@fluent-ui/styles");

var _Dialog = require("../Dialog.styled");

var _Dialog2 = require("../Dialog");

var _Typography = _interopRequireDefault(require("../../Typography"));

var _IconButton = _interopRequireDefault(require("../../IconButton"));

var _icons = require("@fluent-ui/icons");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'DialogTitle';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Dialog.styles, {
  name: name
});

var Title = function Title(props) {
  var children = props.children,
      rest = _objectWithoutProperties(props, ["children"]);

  var classes = useStyles(props);

  var _React$useContext = React.useContext(_Dialog2.DialogContext),
      onChange = _React$useContext.onChange;

  function handleClose() {
    onChange && onChange(false);
  }

  return React.createElement("div", _extends({
    className: classes.title
  }, rest), React.createElement(_Typography["default"], {
    variant: "h6"
  }, children), React.createElement(_IconButton["default"], {
    size: "small",
    style: {
      height: '100%'
    },
    onClick: handleClose
  }, React.createElement(_icons.CloseLine, null)));
};

Title.displayName = "F".concat(name);
Title.propTypes = {
  children: PropTypes.any.isRequired
};
var _default = Title;
exports["default"] = _default;