"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _styles = require("@fluent-ui/styles");

var _Form = require("./Form.styled");

var _Form2 = require("./Form.type");

var _Field = _interopRequireDefault(require("./components/Field"));

var _Form3 = require("./Form.context");

var _Form4 = require("./Form.validator");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Form';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Form.styles, {
  name: name
});
var Form = React.forwardRef(function (props, ref) {
  var classNameProp = props.className,
      children = props.children,
      prefix = props.prefix,
      suffix = props.suffix,
      initialState = props.initialState,
      onSubmit = props.onSubmit,
      rest = _objectWithoutProperties(props, ["className", "children", "prefix", "suffix", "initialState", "onSubmit"]);

  var childrenArray = React.useMemo(function () {
    return React.Children.toArray(children).map(function (child) {
      return !!child.props.rules && child;
    }).filter(function (v) {
      return v;
    });
  }, [children]);
  var fields = React.useMemo(function () {
    return initialState || childrenArray.reduce(function (acc, cur) {
      return _objectSpread({}, acc, _defineProperty({}, cur.props.name, ''));
    }, {});
  }, [childrenArray, initialState]);
  var reducer = React.useCallback(function (state, action) {
    switch (action.type) {
      case 'reset':
        return {
          values: fields,
          errors: {}
        };

      case 'onChange':
        return {
          values: _objectSpread({}, state.values, {}, action.payload),
          errors: state.errors
        };

      case 'onError':
        // eslint-disable-next-line
        var errors = Array.isArray(action.payload) ? action.payload.reduce(function (acc, cur) {
          return _objectSpread({}, acc, _defineProperty({}, cur.field, cur.message));
        }, {}) : {};
        return {
          values: state.values,
          errors: errors
        };

      default:
        throw new Error('The `type` provided by `dispatch` does not conform to the specification');
    }
  }, [fields]);

  var _React$useReducer = React.useReducer(reducer, {
    values: fields,
    errors: {}
  }),
      _React$useReducer2 = _slicedToArray(_React$useReducer, 2),
      state = _React$useReducer2[0],
      dispatch = _React$useReducer2[1];

  var descriptor = React.useMemo(function () {
    return childrenArray.reduce(function (acc, cur) {
      return _objectSpread({}, acc, _defineProperty({}, cur.props.name, cur.props.rules));
    }, {});
  }, [childrenArray]);
  var contextValue = {
    state: state,
    dispatch: dispatch,
    descriptor: descriptor
  }; // Used to control the content triggered by the submit event

  var handleSubmit = React.useCallback(function (e) {
    e.preventDefault();
    (0, _Form4.createValidator)(descriptor, state.values, function (errors) {
      dispatch({
        type: 'onError',
        payload: errors
      });
      onSubmit && onSubmit(state.values, errors);
    });
  }, [state, onSubmit, descriptor]);
  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, classNameProp);
  return React.createElement("form", _extends({
    className: className,
    ref: ref,
    onSubmit: handleSubmit
  }, rest), React.createElement(_Form3.FormContext.Provider, {
    value: contextValue
  }, React.createElement("table", {
    className: classes.table
  }, React.createElement("caption", null, prefix), React.createElement("tbody", null, React.Children.map(children, function (child) {
    return child;
  }), React.createElement("tr", null, React.createElement("td", {
    colSpan: 2
  }, suffix))))));
});
Object.defineProperty(Form, 'Field', {
  get: function get() {
    return _Field["default"];
  }
});
Form.displayName = "F".concat(name);
Form.propTypes = _Form2.FormPropTypes;
var _default = Form;
exports["default"] = _default;