"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _styles = require("@fluent-ui/styles");

var _Field = require("./Field.styled");

var _Form = require("../../Form.type");

var _Typography = _interopRequireDefault(require("../../../Typography"));

var _Transition = _interopRequireDefault(require("../../../Transition"));

var _Form2 = require("../../Form.context");

var _Form3 = require("../../Form.validator");

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'FormField';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Field.styles, {
  name: name
});
var Field = React.forwardRef(function (props, ref) {
  var children = props.children,
      onChange = props.onChange,
      label = props.label,
      name = props.name,
      rules = props.rules,
      rest = _objectWithoutProperties(props, ["children", "onChange", "label", "name", "rules"]);

  var _React$useContext = React.useContext(_Form2.FormContext),
      state = _React$useContext.state,
      dispatch = _React$useContext.dispatch,
      descriptor = _React$useContext.descriptor;

  var _React$useState = React.useState(state.values[name] || ''),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      value = _React$useState2[0],
      setValue = _React$useState2[1];

  var handleValueChange = React.useCallback(function (v) {
    dispatch({
      type: 'onChange',
      payload: _defineProperty({}, name, v)
    });
    onChange ? onChange(v) : setValue(v);
  }, [onChange, dispatch, name]);
  React.useEffect(function () {
    (0, _Form3.createValidator)(descriptor, state.values, function (errors) {
      dispatch({
        type: 'onError',
        payload: errors
      });
    });
  }, [dispatch, descriptor, state.values]);
  var required = React.useMemo(function () {
    return rules ? !!rules.find(function (v) {
      return v.required === true;
    }) : false;
  }, [rules]); // About the error message

  var errors = state.errors;
  var selfError = errors[name];
  var classes = useStyles(props);
  var labelClassName = (0, _classnames["default"])(classes.label, _defineProperty({}, classes.labelRequired, required));
  return React.createElement("tr", {
    ref: ref
  }, label && React.createElement(_Typography["default"], {
    variant: "body1",
    as: "td"
  }, React.createElement("label", {
    className: labelClassName,
    htmlFor: name
  }, label)), React.createElement("td", null, React.cloneElement(children, _objectSpread({
    name: name,
    value: value,
    onChange: handleValueChange,
    error: !!selfError
  }, rest)), React.createElement(_Transition["default"], {
    visible: !!selfError,
    wrapper: false,
    mountOnEnter: true,
    unmountOnExit: true
  }, React.createElement(_Typography["default"], {
    variant: "body2",
    color: "error.default"
  }, selfError))));
});
Field.displayName = 'FFormField';
Field.propTypes = _Form.FieldPropTypes;
var _default = Field;
exports["default"] = _default;