"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Input = require("./Input.styled");

var _Input2 = require("./Input.type");

var _icons = require("@fluent-ui/icons");

var _Transition = _interopRequireDefault(require("../Transition"));

var _TextArea = _interopRequireDefault(require("./components/TextArea"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Input';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Input.styles, {
  name: name
});
var Input = React.forwardRef(function (props, ref) {
  var _classNames;

  var classNameProp = props.className,
      style = props.style,
      value = props.value,
      onChange = props.onChange,
      placeholder = props.placeholder,
      disabled = props.disabled,
      cleared = props.cleared,
      password = props.password,
      error = props.error,
      _props$prefix = props.prefix,
      prefix = _props$prefix === void 0 ? null : _props$prefix,
      _props$suffix = props.suffix,
      suffix = _props$suffix === void 0 ? null : _props$suffix,
      ghost = props.ghost,
      rest = _objectWithoutProperties(props, ["className", "style", "value", "onChange", "placeholder", "disabled", "cleared", "password", "error", "prefix", "suffix", "ghost"]);

  var clearedRef = React.useRef(null);

  var _React$useState = React.useState(0),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      clearedHeight = _React$useState2[0],
      setClearedHeight = _React$useState2[1];

  React.useEffect(function () {
    if (clearedRef && clearedRef.current) {
      setClearedHeight(clearedRef.current.offsetHeight);
    }
  }, []);

  function handleChange(e) {
    onChange && onChange(e ? e.target.value : '');
  }

  function handleClear(e) {
    e.preventDefault();
    e.stopPropagation();
    handleChange(null);
  }

  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, (_classNames = {}, _defineProperty(_classNames, classes.error, error), _defineProperty(_classNames, classes.ghost, ghost), _classNames), classNameProp);
  var clearedInputStyle = React.useMemo(function () {
    return cleared ? {
      paddingRight: clearedHeight + (suffix ? 30 : 0)
    } : {};
  }, [cleared, clearedHeight, suffix]);
  return React.createElement("div", {
    className: classes.wrapper,
    style: style
  }, prefix && React.createElement("div", {
    className: classes.prefix
  }, prefix), React.createElement("input", _extends({
    className: className,
    ref: ref,
    value: value,
    onChange: handleChange,
    placeholder: placeholder,
    disabled: disabled,
    type: password ? 'password' : 'text',
    style: clearedInputStyle
  }, rest)), suffix && React.createElement("div", {
    className: classes.suffix
  }, suffix), cleared && React.createElement(_Transition["default"], {
    visible: !!value,
    wrapper: false
  }, React.createElement("span", {
    className: classes.clearedIcon,
    onClick: handleClear,
    ref: clearedRef,
    style: {
      width: clearedHeight
    }
  }, React.createElement(_icons.CloseLine, null))));
});
Object.defineProperty(Input, 'TextArea', {
  get: function get() {
    return _TextArea["default"];
  }
});
Input.displayName = "F".concat(name);
Input.propTypes = _Input2.InputPropTypes;
Input.defaultProps = {
  prefix: null,
  suffix: null
};
var _default = Input;
exports["default"] = _default;