"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var wrapper = {
  display: 'inline-block',
  position: 'relative',
  minWidth: 160,
  font: 'inherit'
};

var root = function root(theme) {
  return _objectSpread({
    outline: 'none',
    font: 'inherit',
    width: '100%',
    borderRadius: 2,
    border: '2px solid',
    borderColor: theme.colors.standard["default"],
    transition: theme.transitions.input,
    '&:hover': {
      borderColor: theme.colors.standard.dark1
    },
    '&:active, &:focus': {
      borderColor: theme.colors.primary["default"]
    },
    '&:disabled': {
      color: theme.colors.standard.dark2,
      backgroundColor: theme.colors.standard.light1,
      cursor: 'not-allowed',
      pointerEvents: 'none'
    }
  }, theme.sizes.medium.input, {
    '&:not(:first-child)': {
      paddingLeft: 30
    },
    '&:not(:last-child)': {
      paddingRight: 30
    }
  });
};

var error = function error(theme) {
  return {
    borderColor: theme.colors.error["default"],
    '&:hover': {
      borderColor: theme.colors.error["default"]
    },
    '&:active, &:focus': {
      borderColor: theme.colors.error["default"]
    }
  };
};

var clearedIcon = function clearedIcon(theme) {
  return {
    height: '100%',
    position: 'absolute',
    right: 0,
    top: 0,
    fontSize: 12,
    cursor: 'pointer',
    display: 'inline-flex',
    justifyContent: 'center',
    alignItems: 'center',
    transition: theme.transitions.input,
    '&:hover': {
      backgroundColor: theme.colors.primary["default"],
      color: theme.colors.white["default"]
    }
  };
};

var extra = function extra(theme) {
  return {
    position: 'absolute',
    top: '50%',
    transform: 'translateY(-50%)',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    color: theme.colors.standard.transparent3
  };
};

var prefix = function prefix(theme) {
  return _objectSpread({}, extra(theme), {
    left: 12
  });
};

var suffix = function suffix(theme) {
  return function (props) {
    return _objectSpread({}, extra(theme), {
      right: 12 + (props.suffix && !!props.value ? 30 : 0)
    });
  };
};

var ghost = function ghost(theme) {
  return {
    backgroundColor: 'transparent',
    borderColor: theme.colors.standard.transparent1,
    '&:hover': {
      borderColor: theme.colors.standard.transparent2
    },
    '&:active, &:focus': {
      borderColor: theme.colors.standard.transparent3
    }
  };
};

var styles = function styles(theme) {
  return {
    root: root(theme),
    error: error(theme),
    wrapper: wrapper,
    clearedIcon: clearedIcon(theme),
    prefix: prefix(theme),
    suffix: suffix(theme),
    ghost: ghost(theme)
  };
};

exports.styles = styles;