import * as React from 'react';
import * as PropTypes from 'prop-types';
import { StandardProps } from '..';
import TextArea from './components/TextArea';
export declare type InputClassProps = 'root' | 'error' | 'wrapper' | 'clearedIcon' | 'prefix' | 'suffix' | 'ghost';
export interface InputProps extends StandardProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement, 'onChange' | 'prefix'> {
    value?: string;
    onChange?: (value: string) => void;
    placeholder?: string;
    disabled?: boolean;
    cleared?: boolean;
    password?: boolean;
    error?: boolean;
    prefix?: React.ReactNode;
    suffix?: React.ReactNode;
    ghost?: boolean;
}
export declare const InputPropTypes: {
    value: PropTypes.Requireable<string>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    placeholder: PropTypes.Requireable<string>;
    disabled: PropTypes.Requireable<boolean>;
    cleared: PropTypes.Requireable<boolean>;
    password: PropTypes.Requireable<boolean>;
    error: PropTypes.Requireable<boolean>;
    prefix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    suffix: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    ghost: PropTypes.Requireable<boolean>;
};
export interface InputType extends React.ForwardRefExoticComponent<InputProps> {
    TextArea: typeof TextArea;
}
