"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _TextArea = require("./TextArea.styled");

var _TextArea2 = require("./TextArea.type");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'TextArea';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_TextArea.styles, {
  name: name
});
var TextArea = React.forwardRef(function (props, ref) {
  var _classNames;

  var classNameProp = props.className,
      value = props.value,
      onChange = props.onChange,
      placeholder = props.placeholder,
      disabled = props.disabled,
      error = props.error,
      ghost = props.ghost,
      _props$resize = props.resize,
      resize = _props$resize === void 0 ? 'both' : _props$resize,
      rest = _objectWithoutProperties(props, ["className", "value", "onChange", "placeholder", "disabled", "error", "ghost", "resize"]);

  function handleChange(e) {
    onChange && onChange(e ? e.target.value : '');
  }

  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, (_classNames = {}, _defineProperty(_classNames, classes.error, error), _defineProperty(_classNames, classes.ghost, ghost), _defineProperty(_classNames, classes.resize, !!resize), _classNames), classNameProp);
  return React.createElement("textarea", _extends({
    className: className,
    ref: ref,
    value: value,
    onChange: handleChange,
    placeholder: placeholder,
    disabled: disabled
  }, rest));
});
TextArea.displayName = "F".concat(name);
TextArea.propTypes = _TextArea2.TextAreaPropTypes;
TextArea.defaultProps = {
  resize: 'both'
};
var _default = TextArea;
exports["default"] = _default;