"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Item = require("./Item.styled");

var _Item2 = require("./Item.type");

var _Box = _interopRequireDefault(require("../Box"));

var _Navigation = require("../Navigation/Navigation");

var _List = require("../List/List");

var _Command = require("../Command/Command");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Item';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Item.styles, {
  name: name
});
var Item = React.forwardRef(function (props, ref) {
  var _classNames2, _classNames3;

  var _props$as = props.as,
      as = _props$as === void 0 ? 'div' : _props$as,
      classNameProp = props.className,
      value = props.value,
      prefix = props.prefix,
      active = props.active,
      children = props.children,
      onClick = props.onClick,
      rest = _objectWithoutProperties(props, ["as", "className", "value", "prefix", "active", "children", "onClick"]); // handle active item


  var _React$useContext = React.useContext(_Navigation.NavigationContext),
      activeID = _React$useContext.value,
      onChange = _React$useContext.onChange,
      expanded = _React$useContext.expanded,
      navigationReveal = _React$useContext.reveal,
      horizontal = _React$useContext.horizontal;

  var _React$useContext2 = React.useContext(_List.ListContext),
      listReveal = _React$useContext2.reveal;

  var commandReveal = React.useContext(_Command.CommandContext);
  var reveal = navigationReveal || listReveal || commandReveal;
  var handleItemClick = React.useCallback(function (e) {
    onClick && onClick(e);
    onChange && value && onChange(value);
  }, [value, onChange, onClick]);

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      _active = _React$useState2[0],
      setActive = _React$useState2[1];

  React.useEffect(function () {
    if (value && activeID) {
      if (activeID === value) {
        setActive(true);
      } else {
        setActive(false);
      }
    }
  }, [activeID, value]);
  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, _defineProperty({}, classes.reveal, reveal), classNameProp);
  var activeBarClassName = (0, _classnames["default"])(classes.activeBar, (_classNames2 = {}, _defineProperty(_classNames2, classes.activeBarHorizontal, horizontal), _defineProperty(_classNames2, classes.activeBarActive, active || _active), _classNames2));
  var textClassName = (0, _classnames["default"])(classes.text, (_classNames3 = {}, _defineProperty(_classNames3, classes.textExpanded, expanded), _defineProperty(_classNames3, classes.textNoChildren, !children), _defineProperty(_classNames3, classes.textHasPrefix, !!prefix && expanded), _classNames3));
  return React.createElement(_Box["default"], _extends({
    className: className,
    ref: ref,
    as: as,
    onClick: handleItemClick
  }, rest), !!value && React.createElement("div", {
    className: activeBarClassName
  }), !!prefix && React.createElement("div", {
    className: classes.prefixRoot
  }, prefix), React.createElement("div", {
    className: textClassName
  }, children));
});
Item.displayName = "F".concat(name);
Item.propTypes = _Item2.ItemPropTypes;
var _default = Item;
exports["default"] = _default;