"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = exports.ListContext = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _List = require("./List.styled");

var _List2 = require("./List.type");

var _hooks = require("@fluent-ui/hooks");

var _Box = _interopRequireDefault(require("../Box"));

var _Typography = _interopRequireDefault(require("../Typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ListContext = React.createContext({
  reveal: false,
  acrylic: false
});
exports.ListContext = ListContext;
var name = 'List';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_List.styles, {
  name: name
});
var List = React.forwardRef(function (props, ref) {
  var _props$as = props.as,
      as = _props$as === void 0 ? 'div' : _props$as,
      classNameProp = props.className,
      children = props.children,
      title = props.title,
      acrylic = props.acrylic,
      reveal = props.reveal,
      rest = _objectWithoutProperties(props, ["as", "className", "children", "title", "acrylic", "reveal"]); // handle Reveal Effects


  var _useReveal = (0, _hooks.useReveal)(66),
      _useReveal2 = _slicedToArray(_useReveal, 1),
      RevealWrapper = _useReveal2[0];

  var theChildren = reveal ? React.useMemo(function () {
    return React.Children.map(children, function (child, i) {
      if (child.type && child.type.displayName === 'FItem') {
        return React.createElement(RevealWrapper, {
          key: i
        }, child);
      }

      return child;
    });
  }, [children]) : children;
  var contextValue = {
    reveal: reveal,
    acrylic: acrylic
  };
  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, classNameProp);
  return React.createElement(ListContext.Provider, {
    value: contextValue
  }, React.createElement(_Box["default"], _extends({
    className: className,
    ref: ref,
    as: as,
    acrylic: acrylic
  }, rest), title && React.createElement(_Typography["default"], {
    className: classes.title,
    variant: "subtitle2"
  }, title), theChildren));
});
List.displayName = "F".concat(name);
List.propTypes = _List2.ListPropTypes;
var _default = List;
exports["default"] = _default;