"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;

var root = function root(theme) {
  return function (_ref) {
    var reveal = _ref.reveal;
    return {
      width: '100%',
      maxWidth: 360,
      padding: '8px 0',
      boxShadow: theme.shadows[2],
      backgroundColor: reveal ? theme.colors.standard.light2 : theme.colors.white["default"]
    };
  };
};

var title = function title(theme) {
  return {
    padding: '0 12px 6px',
    position: 'sticky',
    top: 0,
    zIndex: 1,
    fontWeight: 500,
    color: theme.colors.standard.transparent3
  };
};

var styles = function styles(theme) {
  return {
    root: root(theme),
    title: title(theme)
  };
};

exports.styles = styles;