"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Radio = require("./Radio.type");

var _Radio2 = require("./Radio.styled");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Radio';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Radio2.styles, {
  name: name
});
var Radio = React.forwardRef(function (props, ref) {
  var _classNames, _classNames2;

  var _props$as = props.as,
      Component = _props$as === void 0 ? 'div' : _props$as,
      classNameProp = props.className,
      style = props.style,
      checked = props.checked,
      value = props.value,
      onChange = props.onChange,
      disabled = props.disabled,
      rest = _objectWithoutProperties(props, ["as", "className", "style", "checked", "value", "onChange", "disabled"]);

  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, (_classNames = {}, _defineProperty(_classNames, classes.checked, checked), _defineProperty(_classNames, classes.disabled, disabled), _classNames), classNameProp);
  var circleClassName = (0, _classnames["default"])(classes.circle, (_classNames2 = {}, _defineProperty(_classNames2, classes.circleChecked, checked), _defineProperty(_classNames2, classes.circleDisabled, disabled), _classNames2));

  function handleChange(e) {
    onChange && onChange(e.target.value);
  }

  return React.createElement(Component, {
    className: className,
    style: style
  }, React.createElement("div", {
    className: circleClassName
  }), React.createElement("input", _extends({
    ref: ref,
    type: "radio",
    checked: checked,
    value: value,
    onChange: handleChange,
    disabled: disabled
  }, rest)));
});
Radio.displayName = "F".concat(name);
Radio.propTypes = _Radio.RadioPropTypes;
var _default = Radio;
exports["default"] = _default;