"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Select = require("./Select.styled");

var _hooks = require("@fluent-ui/hooks");

var _icons = require("@fluent-ui/icons");

var _Select2 = require("./Select.type");

var _Transition = _interopRequireDefault(require("../Transition"));

var _List = _interopRequireDefault(require("../List"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Select';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Select.styles, {
  name: name
});
var Select = React.forwardRef(function (props, ref) {
  var _props$as = props.as,
      Component = _props$as === void 0 ? 'span' : _props$as,
      classNameProp = props.className,
      style = props.style,
      value = props.value,
      onChange = props.onChange,
      _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      children = props.children,
      rest = _objectWithoutProperties(props, ["as", "className", "style", "value", "onChange", "disabled", "children"]);

  var _usePopper = (0, _hooks.usePopper)({
    placement: 'bottom-start',
    positionFixed: false
  }),
      _usePopper2 = _slicedToArray(_usePopper, 2),
      referenceRef = _usePopper2[0],
      popperRef = _usePopper2[1];

  var _React$useState = React.useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      visible = _React$useState2[0],
      setVisible = _React$useState2[1];

  var handleVisible = React.useCallback(function (status) {
    disabled !== true && setVisible(status);
  }, [disabled]);

  var _useClick = (0, _hooks.useClick)(handleVisible),
      _useClick2 = _slicedToArray(_useClick, 2),
      _ = _useClick2[0],
      bind = _useClick2[1];

  (0, _hooks.useClickOutside)(referenceRef, function () {
    setVisible(false);
  });

  var _React$useState3 = React.useState(''),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      currentText = _React$useState4[0],
      setCurrentText = _React$useState4[1];

  React.useEffect(function () {
    React.Children.forEach(children, function (child) {
      var active = child.props.value === value;
      active && setCurrentText(child.props.children);
    });
  }, [children, value]);
  var theChildren = React.Children.map(children, function (child) {
    function onClick() {
      child.props.value && onChange && onChange(child.props.value);
      setCurrentText(child.props.children);
      setVisible(false);
    }

    var active = child.props.value === value;
    return React.cloneElement(child, {
      onClick: onClick,
      active: active
    });
  });
  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, _defineProperty({}, classes.disabled, disabled), classNameProp);
  var selectClassName = (0, _classnames["default"])(classes.select, _defineProperty({}, classes.selectDisabled, disabled));
  var iconClassName = (0, _classnames["default"])(classes.icon, _defineProperty({}, classes.disabledIcon, disabled));
  return React.createElement(Component, _extends({
    className: className,
    style: style,
    ref: referenceRef
  }, bind), React.createElement("button", {
    className: selectClassName
  }, currentText), React.createElement("span", {
    className: iconClassName
  }, React.createElement(_icons.ArrowDownSLine, null)), React.createElement("input", _extends({
    type: "hidden",
    value: value,
    disabled: disabled,
    ref: ref
  }, rest)), React.createElement(_Transition["default"], {
    type: "grow",
    visible: visible,
    wrapper: false,
    mountOnEnter: true,
    unmountOnExit: true
  }, React.createElement(_List["default"], {
    zIndex: 1002,
    ref: popperRef
  }, theChildren)));
});
Select.displayName = "F".concat(name);
Select.propTypes = _Select2.SelectPropTypes;
Select.defaultProps = {
  disabled: false
};
var _default = Select;
exports["default"] = _default;