"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;

var root = function root(theme) {
  return {
    display: 'inline-block',
    borderRadius: '50%',
    border: '1.5px solid',
    borderColor: "".concat(theme.colors.primary["default"], " ").concat(theme.colors.primary.light3, " ").concat(theme.colors.primary.light3),
    '@global': {
      '@keyframes rotate': {
        from: {
          transform: 'rotate(0deg)'
        },
        to: {
          transform: 'rotate(360deg)'
        }
      }
    },
    animation: '$rotate 1.3s cubic-bezier(0.5, 0.2, 0.3, 0.65) infinite'
  };
};

var sizeSmall = {
  width: 16,
  height: 16
};
var sizeMedium = {
  width: 20,
  height: 20
};
var sizeLarge = {
  width: 28,
  height: 28
};

var styles = function styles(theme) {
  return {
    root: root(theme),
    sizeSmall: sizeSmall,
    sizeMedium: sizeMedium,
    sizeLarge: sizeLarge
  };
};

exports.styles = styles;