"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Table = require("./Table.styled");

var _Table2 = require("./Table.type");

var _Head = _interopRequireDefault(require("./components/Head"));

var _Body = _interopRequireDefault(require("./components/Body"));

var _Row = _interopRequireDefault(require("./components/Row"));

var _Cell = _interopRequireDefault(require("./components/Cell"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function getColumnsChildren(columns, data) {
  var theHeadChildren = columns.map(function (cell) {
    return React.createElement(_Cell["default"], {
      key: cell.field
    }, cell.title);
  });
  var theBodyChildren = data.map(function (row, index) {
    return React.createElement(_Row["default"], {
      key: row.key
    }, columns.map(function (cell) {
      var text = row[cell.field];
      var content = typeof cell.render === 'function' ? cell.render(text, row, index) : text;
      return React.createElement(_Cell["default"], {
        key: text
      }, content);
    }));
  });
  return React.createElement(React.Fragment, null, React.createElement(_Head["default"], null, React.createElement(_Row["default"], null, theHeadChildren)), React.createElement(_Body["default"], null, theBodyChildren));
}

var name = 'Table';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Table.styles, {
  name: name
});

function Table(props) {
  var classNameProp = props.className,
      data = props.data,
      columns = props.columns,
      children = props.children,
      rest = _objectWithoutProperties(props, ["className", "data", "columns", "children"]);

  var theChildren = columns ? getColumnsChildren(columns, data) : children;
  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, classNameProp);
  return React.createElement("table", _extends({
    className: className
  }, rest), theChildren);
}

Table.displayName = "F".concat(name);
Table.propTypes = _Table2.TablePropTypes;
var _default = Table;
exports["default"] = _default;