"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;

var root = function root(theme) {
  return {
    position: 'relative',
    overflow: 'hidden',
    display: 'table',
    borderSpacing: 0,
    borderCollapse: 'collapse',
    boxShadow: theme.shadows[1]
  };
};

var headRoot = {
  display: 'table-header-group'
};
var bodyRoot = {
  display: 'table-row-group'
};
var footRoot = {
  display: 'table-row-group'
};
var rowRoot = {
  display: 'table-row',
  color: 'inherit',
  outline: 'none',
  textAlign: 'inherit'
};

var rowBody = function rowBody(theme) {
  return {
    '&:hover': {
      backgroundColor: theme.colors.standard.light2
    }
  };
};

var cellRoot = function cellRoot(theme) {
  return {
    display: 'table-cell',
    padding: '14px 40px 14px 16px',
    verticalAlign: 'middle',
    fontSize: '0.875rem',
    fontWeight: 400,
    lineHeight: 1.5,
    letterSpacing: '0.015em',
    borderBottom: "1px solid ".concat(theme.colors.standard["default"])
  };
};

var headCellRoot = function headCellRoot(theme) {
  return {
    display: 'table-cell',
    padding: '14px 40px 14px 16px',
    verticalAlign: 'middle',
    fontSize: '0.75rem',
    fontWeight: 500,
    lineHeight: 1.3,
    letterSpacing: '0.015em',
    borderBottom: "1px solid ".concat(theme.colors.standard["default"])
  };
};

var cellTextAlignLeft = {
  textAlign: 'left'
};
var cellTextAlignRight = {
  textAlign: 'right'
};
var cellTextAlignCenter = {
  textAlign: 'center'
};
var cellTextAlignJustify = {
  textAlign: 'justify'
};

var styles = function styles(theme) {
  return {
    root: root(theme),
    headRoot: headRoot,
    bodyRoot: bodyRoot,
    footRoot: footRoot,
    rowRoot: rowRoot,
    rowBody: rowBody(theme),
    cellRoot: cellRoot(theme),
    headCellRoot: headCellRoot(theme),
    cellTextAlignLeft: cellTextAlignLeft,
    cellTextAlignRight: cellTextAlignRight,
    cellTextAlignCenter: cellTextAlignCenter,
    cellTextAlignJustify: cellTextAlignJustify
  };
};

exports.styles = styles;