"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _styles = require("@fluent-ui/styles");

var _Toast = require("./Toast.styled");

var _Toast2 = require("./Toast.type");

var _Portal = _interopRequireDefault(require("../Portal"));

var _Transition = _interopRequireDefault(require("../Transition"));

var _Box = _interopRequireDefault(require("../Box"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Toast';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Toast.styles, {
  name: name
});
var Toast = React.forwardRef(function (props, ref) {
  var _classNames;

  var _props$as = props.as,
      as = _props$as === void 0 ? 'div' : _props$as,
      classNameProp = props.className,
      children = props.children,
      _props$visible = props.visible,
      visible = _props$visible === void 0 ? false : _props$visible,
      actions = props.actions,
      _props$placement = props.placement,
      placement = _props$placement === void 0 ? 'top' : _props$placement,
      rest = _objectWithoutProperties(props, ["as", "className", "children", "visible", "actions", "placement"]);

  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, (_classNames = {}, _defineProperty(_classNames, classes.placementTopStart, placement === 'top-start'), _defineProperty(_classNames, classes.placementTop, placement === 'top'), _defineProperty(_classNames, classes.placementTopEnd, placement === 'top-end'), _defineProperty(_classNames, classes.placementBottomStart, placement === 'bottom-start'), _defineProperty(_classNames, classes.placementBottom, placement === 'bottom'), _defineProperty(_classNames, classes.placementBottomEnd, placement === 'bottom-end'), _defineProperty(_classNames, classes.placementCenter, placement === 'center'), _classNames), classNameProp);
  return React.createElement(_Portal["default"], null, React.createElement(_Transition["default"], {
    visible: visible,
    wrapper: false,
    mountOnEnter: true,
    unmountOnExit: true
  }, React.createElement(_Box["default"], _extends({
    className: className,
    ref: ref,
    as: as,
    placement: placement
  }, rest), React.createElement("div", {
    className: classes.container
  }, children), React.createElement("div", {
    className: classes.actions
  }, actions))));
});
Toast.displayName = "F".concat(name);
Toast.propTypes = _Toast2.ToastPropTypes;
var _default = Toast;
exports["default"] = _default;