import * as React from 'react';
import * as PropTypes from 'prop-types';
import { StandardProps, StyledProps } from '..';
export declare type ToastClassProps = 'root' | 'placementTopStart' | 'placementTop' | 'placementTopEnd' | 'placementBottomStart' | 'placementBottom' | 'placementBottomEnd' | 'placementCenter' | 'container' | 'actions';
export declare type Placement = 'top-start' | 'top' | 'top-end' | 'bottom-end' | 'bottom' | 'bottom-start' | 'center';
export interface ToastProps extends StandardProps, StyledProps {
    children: React.ReactChild;
    visible: boolean;
    actions?: React.ReactElement | React.ReactElement[];
    placement?: Placement;
}
export declare const ToastPropTypes: {
    children: PropTypes.Validator<string | number | PropTypes.ReactElementLike>;
    visible: PropTypes.Validator<boolean>;
    actions: PropTypes.Requireable<any>;
    placement: PropTypes.Requireable<Placement>;
};
