import * as React from 'react';
import * as PropTypes from 'prop-types';
import { StandardProps, StyledProps } from '..';
export declare type ToggleClassProps = 'root' | 'checked' | 'disabled' | 'checkedAndDisabled' | 'circle' | 'circleChecked' | 'circleDisabled' | 'circleCheckedAndDisabled';
export interface ToggleProps extends StandardProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement, 'onChange'>, StyledProps {
    checked?: boolean;
    value?: string;
    onChange?: (checked: boolean) => void;
    disabled?: boolean;
}
export declare const TogglePropTypes: {
    checked: PropTypes.Requireable<boolean>;
    value: PropTypes.Requireable<string>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    disabled: PropTypes.Requireable<boolean>;
};
