"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.name = void 0;

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _hooks = require("@fluent-ui/hooks");

var _styles = require("@fluent-ui/styles");

var _Tooltip = require("./Tooltip.styled");

var _Tooltip2 = require("./Tooltip.type");

var _Portal = _interopRequireDefault(require("../Portal"));

var _Transition = _interopRequireDefault(require("../Transition"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var name = 'Tooltip';
exports.name = name;
var useStyles = (0, _styles.createUseStyles)(_Tooltip.styles, {
  name: name
});

var Tooltip = function Tooltip(props) {
  var _props$as = props.as,
      Component = _props$as === void 0 ? 'div' : _props$as,
      classNameProp = props.className,
      children = props.children,
      title = props.title,
      visible = props.visible,
      onChange = props.onChange,
      _props$trigger = props.trigger,
      trigger = _props$trigger === void 0 ? 'hover' : _props$trigger,
      propperOptions = _objectWithoutProperties(props, ["as", "className", "children", "title", "visible", "onChange", "trigger"]);

  var _usePopper = (0, _hooks.usePopper)(propperOptions),
      _usePopper2 = _slicedToArray(_usePopper, 2),
      referenceRef = _usePopper2[0],
      popperRef = _usePopper2[1];

  var isControlled = React.useMemo(function () {
    return !!visible;
  }, [visible]);
  var hoverHandler = (0, _hooks.useHover)(onChange);
  var clickHandler = (0, _hooks.useClick)(onChange);
  (0, _hooks.useClickOutside)(referenceRef, function () {
    clickHandler[2] && clickHandler[2](false);
    onChange && onChange(false);
  });
  var touchHandler = (0, _hooks.useTouch)(onChange);
  var focusHandler = (0, _hooks.useFocus)(onChange);
  var triggerMap = {
    hover: hoverHandler,
    click: clickHandler,
    touch: touchHandler,
    focus: focusHandler
  };

  var _triggerMap$trigger = _slicedToArray(triggerMap[trigger], 2),
      currentStatus = _triggerMap$trigger[0],
      bind = _triggerMap$trigger[1];

  var isVisible = isControlled ? visible : currentStatus;
  var classes = useStyles(props);
  var className = (0, _classnames["default"])(classes.root, classNameProp);
  var content = typeof title === 'string' ? React.createElement(Component, {
    className: className,
    ref: popperRef
  }, title) : React.cloneElement(title, _objectSpread({
    ref: popperRef
  }, bind));
  return React.createElement(React.Fragment, null, React.cloneElement(children, _objectSpread({
    ref: referenceRef
  }, bind)), React.createElement(_Portal["default"], null, React.createElement(_Transition["default"], {
    visible: isVisible,
    wrapper: false,
    mountOnEnter: true,
    unmountOnExit: true
  }, content)));
};

Tooltip.displayName = 'FTooltip';
Tooltip.propTypes = _Tooltip2.TooltipPropTypes;
Tooltip.defaultProps = {
  trigger: 'hover'
};
var _default = Tooltip;
exports["default"] = _default;