"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;
var root = {
  marginTop: 0,
  marginBottom: 0
};

var variants = function variants(theme) {
  return function (_ref) {
    var _ref$variant = _ref.variant,
        variant = _ref$variant === void 0 ? 'body1' : _ref$variant;
    return theme.typographies.variants[variant];
  };
};

var gutterTop = {
  marginTop: '0.65em'
};
var gutterBottom = {
  marginBottom: '0.35em'
};
var noWrap = {
  overflow: 'hidden',
  whiteSpace: 'nowrap',
  textOverflow: 'ellipsis'
};

var styles = function styles(theme) {
  return {
    root: root,
    variants: variants(theme),
    gutterTop: gutterTop,
    gutterBottom: gutterBottom,
    noWrap: noWrap
  };
};

exports.styles = styles;