import * as React from 'react';
import * as PropTypes from 'prop-types';
import { StandardProps, StyledProps } from '..';
export declare type DrawerClassProps = 'root' | 'mask';
declare type Anchor = 'left' | 'top' | 'right' | 'bottom';
export interface DrawerProps extends StandardProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement, 'onChange'>, StyledProps {
    children: React.ReactElement;
    visible: boolean;
    onChange?: (visible: boolean) => void;
    anchor?: Anchor;
}
export declare const DrawerPropTypes: {
    children: PropTypes.Validator<PropTypes.ReactElementLike>;
    visible: PropTypes.Validator<boolean>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    anchor: PropTypes.Requireable<import("../FormLabel").Position>;
};
export {};
