function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import * as React from 'react';
import classNames from 'classnames';
import { createUseStyles } from '@fluent-ui/styles';
import { styles } from './TextArea.styled';
import { TextAreaPropTypes } from './TextArea.type';
export const name = 'TextArea';
const useStyles = createUseStyles(styles, {
  name
});
const TextArea = React.forwardRef((props, ref) => {
  const {
    className: classNameProp,
    value,
    onChange,
    placeholder,
    disabled,
    error,
    ghost,
    resize = 'both',
    ...rest
  } = props;

  function handleChange(e) {
    onChange && onChange(e ? e.target.value : '');
  }

  const classes = useStyles(props);
  const className = classNames(classes.root, {
    [classes.error]: error,
    [classes.ghost]: ghost,
    [classes.resize]: !!resize
  }, classNameProp);
  return React.createElement("textarea", _extends({
    className: className,
    ref: ref,
    value: value,
    onChange: handleChange,
    placeholder: placeholder,
    disabled: disabled
  }, rest));
});
TextArea.displayName = `F${name}`;
TextArea.propTypes = TextAreaPropTypes;
TextArea.defaultProps = {
  resize: 'both'
};
export default TextArea;