import { StandardProps } from '../..';
import * as React from 'react';
import * as PropTypes from 'prop-types';
export declare type TextAreaClassProps = 'root' | 'error' | 'ghost' | 'resize';
declare type Resize = 'none' | 'both' | 'horizontal' | 'vertical' | 'block' | 'inline';
export interface TextAreaProps extends StandardProps<React.TextareaHTMLAttributes<HTMLTextAreaElement>, HTMLTextAreaElement, 'onChange'> {
    value?: string;
    onChange?: (value: string) => void;
    placeholder?: string;
    disabled?: boolean;
    error?: boolean;
    ghost?: boolean;
    resize?: Resize;
}
export declare const TextAreaPropTypes: {
    value: PropTypes.Requireable<string>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    placeholder: PropTypes.Requireable<string>;
    disabled: PropTypes.Requireable<boolean>;
    error: PropTypes.Requireable<boolean>;
    ghost: PropTypes.Requireable<boolean>;
    resize: PropTypes.Requireable<Resize>;
};
export {};
