import * as React from 'react';
import * as PropTypes from 'prop-types';
import { StyledProps } from '..';
import { NavigationID } from '../Navigation';
import { BoxProps } from '../Box';
export declare type ItemClassProps = 'root' | 'reveal' | 'activeBar' | 'activeBarHorizontal' | 'activeBarActive' | 'prefixRoot' | 'text' | 'textExpanded' | 'textNoChildren' | 'textHasPrefix';
export interface ItemProps extends Omit<BoxProps, 'prefix'>, Omit<StyledProps, 'as'> {
    value?: NavigationID;
    prefix?: React.ReactElement;
    active?: boolean;
    children?: React.ReactChild;
    onClick?: React.MouseEventHandler<HTMLDivElement>;
}
export declare const ItemPropTypes: {
    value: PropTypes.Requireable<string | number>;
    prefix: PropTypes.Requireable<PropTypes.ReactElementLike>;
    active: PropTypes.Requireable<boolean>;
    children: PropTypes.Requireable<string | number | PropTypes.ReactElementLike>;
    onClick: PropTypes.Requireable<(...args: any[]) => any>;
};
