import * as React from 'react';
import * as PropTypes from 'prop-types';
import { BoxProps } from '../Box';
export declare type ItemGroupClassProps = 'root' | 'level' | 'float' | 'titleRoot' | 'titleActive' | 'titleFloatAndHorizontal' | 'titlePrefix' | 'titlePrefixAcrylic' | 'titlePrefixNotFloatOpen' | 'titlePrefixNotFloatClose' | 'titlePrefixHorizontal' | 'titlePrefixExpanded';
declare type Shrink = 'expand' | 'float';
export interface ItemGroupProps extends Omit<BoxProps, 'prefix'> {
    level?: number;
    title?: string;
    prefix?: React.ReactElement;
    children: React.ReactElement | React.ReactElement[];
    shrink?: Shrink;
}
export declare const ItemGroupPropTypes: {
    level: PropTypes.Requireable<number>;
    title: PropTypes.Requireable<string>;
    prefix: PropTypes.Requireable<PropTypes.ReactElementLike>;
    children: PropTypes.Validator<any>;
    shrink: PropTypes.Requireable<Shrink>;
    theme: PropTypes.Requireable<object>;
    acrylic: PropTypes.Requireable<boolean>;
    as: PropTypes.Requireable<"symbol" | "object" | "big" | "link" | "small" | "sub" | "sup" | "track" | "progress" | "a" | "abbr" | "address" | "area" | "article" | "aside" | "audio" | "b" | "base" | "bdi" | "bdo" | "blockquote" | "body" | "br" | "button" | "canvas" | "caption" | "cite" | "code" | "col" | "colgroup" | "data" | "datalist" | "dd" | "del" | "details" | "dfn" | "dialog" | "div" | "dl" | "dt" | "em" | "embed" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "head" | "header" | "hgroup" | "hr" | "html" | "i" | "iframe" | "img" | "input" | "ins" | "kbd" | "label" | "legend" | "li" | "main" | "map" | "mark" | "menu" | "meta" | "meter" | "nav" | "noscript" | "ol" | "optgroup" | "option" | "output" | "p" | "param" | "picture" | "pre" | "q" | "rp" | "rt" | "ruby" | "s" | "samp" | "script" | "section" | "select" | "source" | "span" | "strong" | "style" | "summary" | "table" | "tbody" | "td" | "template" | "textarea" | "tfoot" | "th" | "thead" | "time" | "title" | "tr" | "u" | "ul" | "var" | "video" | "wbr" | "circle" | "clipPath" | "defs" | "desc" | "ellipse" | "feBlend" | "feColorMatrix" | "feComponentTransfer" | "feComposite" | "feConvolveMatrix" | "feDiffuseLighting" | "feDisplacementMap" | "feDistantLight" | "feFlood" | "feFuncA" | "feFuncB" | "feFuncG" | "feFuncR" | "feGaussianBlur" | "feImage" | "feMerge" | "feMergeNode" | "feMorphology" | "feOffset" | "fePointLight" | "feSpecularLighting" | "feSpotLight" | "feTile" | "feTurbulence" | "filter" | "foreignObject" | "g" | "image" | "line" | "linearGradient" | "marker" | "mask" | "metadata" | "path" | "pattern" | "polygon" | "polyline" | "radialGradient" | "rect" | "stop" | "svg" | "switch" | "text" | "textPath" | "tspan" | "use" | "view" | "menuitem" | "keygen" | "noindex" | "webview" | "animate" | "animateMotion" | "animateTransform" | "feDropShadow" | "mpath">;
};
export {};
