import * as React from 'react';
import * as PropTypes from 'prop-types';
import { StandardProps, StyledProps } from '..';
export declare type SelectClassProps = 'root' | 'disabled' | 'select' | 'selectDisabled' | 'icon' | 'disabledIcon';
export interface SelectProps extends StandardProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement, 'onChange'>, StyledProps {
    value?: string | number;
    onChange?: (value: string | number) => void;
    disabled?: boolean;
    children: React.ReactElement | React.ReactElement[];
}
export declare const SelectPropTypes: {
    value: PropTypes.Requireable<string | number>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    disabled: PropTypes.Requireable<boolean>;
    children: PropTypes.Validator<any>;
};
