import * as React from 'react';
import * as PropTypes from 'prop-types';
import { usePropperOptions } from '@fluent-ui/hooks';
import { StandardProps, StyledProps } from '../';
export declare type TooltipClassProps = 'root';
declare type Trigger = 'hover' | 'click' | 'touch' | 'focus';
export interface TooltipProps extends usePropperOptions, Omit<StandardProps, 'title' | 'onChange'>, StyledProps {
    children: React.ReactElement;
    title: React.ReactElement | string;
    visible?: boolean;
    onChange?: (visible: boolean) => void;
    trigger?: Trigger;
}
export declare const TooltipPropTypes: {
    children: PropTypes.Validator<PropTypes.ReactElementLike>;
    title: PropTypes.Validator<string | PropTypes.ReactElementLike>;
    visible: PropTypes.Requireable<boolean>;
    onChange: PropTypes.Requireable<(...args: any[]) => any>;
    trigger: PropTypes.Requireable<Trigger>;
};
export {};
