/// <reference types="react" />
import * as PropTypes from 'prop-types';
import { BoxProps } from '../Box';
import { StyledProps } from '../';
export declare type TypographyClassProps = 'root' | 'variants' | 'gutterTop' | 'gutterBottom' | 'noWrap';
export interface VariantMapping {
    h1: keyof JSX.IntrinsicElements;
    h2: keyof JSX.IntrinsicElements;
    h3: keyof JSX.IntrinsicElements;
    h4: keyof JSX.IntrinsicElements;
    h5: keyof JSX.IntrinsicElements;
    h6: keyof JSX.IntrinsicElements;
    subtitle1: keyof JSX.IntrinsicElements;
    subtitle2: keyof JSX.IntrinsicElements;
    body1: keyof JSX.IntrinsicElements;
    body2: keyof JSX.IntrinsicElements;
}
export declare type Variant = 'h1' | 'h2' | 'h3' | 'h4' | 'h5' | 'h6' | 'subtitle1' | 'subtitle2' | 'body1' | 'body2';
export interface TypographyProps extends BoxProps, StyledProps {
    variant?: Variant;
    variantMapping?: VariantMapping;
    gutterTop?: boolean;
    gutterBottom?: boolean;
    noWrap?: boolean;
}
export declare const TypographyPropTypes: {
    theme: PropTypes.Requireable<object>;
    acrylic: PropTypes.Requireable<boolean>;
    children: PropTypes.Requireable<PropTypes.ReactNodeLike>;
    as: PropTypes.Requireable<"symbol" | "object" | "big" | "link" | "small" | "sub" | "sup" | "track" | "progress" | "a" | "abbr" | "address" | "area" | "article" | "aside" | "audio" | "b" | "base" | "bdi" | "bdo" | "blockquote" | "body" | "br" | "button" | "canvas" | "caption" | "cite" | "code" | "col" | "colgroup" | "data" | "datalist" | "dd" | "del" | "details" | "dfn" | "dialog" | "div" | "dl" | "dt" | "em" | "embed" | "fieldset" | "figcaption" | "figure" | "footer" | "form" | "h1" | "h2" | "h3" | "h4" | "h5" | "h6" | "head" | "header" | "hgroup" | "hr" | "html" | "i" | "iframe" | "img" | "input" | "ins" | "kbd" | "label" | "legend" | "li" | "main" | "map" | "mark" | "menu" | "meta" | "meter" | "nav" | "noscript" | "ol" | "optgroup" | "option" | "output" | "p" | "param" | "picture" | "pre" | "q" | "rp" | "rt" | "ruby" | "s" | "samp" | "script" | "section" | "select" | "source" | "span" | "strong" | "style" | "summary" | "table" | "tbody" | "td" | "template" | "textarea" | "tfoot" | "th" | "thead" | "time" | "title" | "tr" | "u" | "ul" | "var" | "video" | "wbr" | "circle" | "clipPath" | "defs" | "desc" | "ellipse" | "feBlend" | "feColorMatrix" | "feComponentTransfer" | "feComposite" | "feConvolveMatrix" | "feDiffuseLighting" | "feDisplacementMap" | "feDistantLight" | "feFlood" | "feFuncA" | "feFuncB" | "feFuncG" | "feFuncR" | "feGaussianBlur" | "feImage" | "feMerge" | "feMergeNode" | "feMorphology" | "feOffset" | "fePointLight" | "feSpecularLighting" | "feSpotLight" | "feTile" | "feTurbulence" | "filter" | "foreignObject" | "g" | "image" | "line" | "linearGradient" | "marker" | "mask" | "metadata" | "path" | "pattern" | "polygon" | "polyline" | "radialGradient" | "rect" | "stop" | "svg" | "switch" | "text" | "textPath" | "tspan" | "use" | "view" | "menuitem" | "keygen" | "noindex" | "webview" | "animate" | "animateMotion" | "animateTransform" | "feDropShadow" | "mpath">;
    variant: PropTypes.Requireable<Variant>;
    variantMapping: PropTypes.Requireable<any>;
    gutterTop: PropTypes.Requireable<boolean>;
    gutterBottom: PropTypes.Requireable<boolean>;
    noWrap: PropTypes.Requireable<boolean>;
};
