import * as CSS from 'csstype';
interface Variants {
    h1?: any;
    h2?: any;
    h3?: any;
    h4?: any;
    h5?: any;
    h6?: any;
    subtitle1?: any;
    subtitle2?: any;
    body1?: any;
    body2?: any;
}
export interface Typographies {
    fontFamily?: CSS.FontFamilyProperty;
    fontSize?: CSS.FontSizeProperty<number>;
    htmlFontSize?: CSS.FontSizeProperty<number>;
    fontWeightLight?: number;
    fontWeightRegular?: number;
    fontWeightMedium?: number;
    fontWeightBold?: number;
    variants?: Variants;
}
export declare const defaultFontFamily: string;
export declare const defaultFontSize = 14;
export declare const defaultHtmlFontSize = 16;
export declare const defaultFontWeightLight = 300;
export declare const defaultFontWeightRegular = 400;
export declare const defaultFontWeightMedium = 500;
export declare const defaultFontWeightBold = 700;
export declare const defaultVariants: Variants;
declare function createTypography(typographies: Typographies): Typographies;
export default createTypography;
