"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _utils = require("../utils");

function createSize() {
  var sizes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var defaultSizes = {
    small: {
      button: {
        padding: '0 8px'
      },
      iconButton: {
        padding: 8,
        fontSize: '0.8em'
      }
    },
    medium: {
      button: {
        padding: '3px 12px'
      },
      iconButton: {
        padding: 12
      },
      input: {
        padding: '6px 12px'
      }
    },
    large: {
      button: {
        padding: '8px 42px'
      },
      iconButton: {
        padding: 16,
        fontSize: '1.2em'
      }
    }
  };
  return (0, _utils.deepMerge)(sizes, defaultSizes);
}

var _default = createSize;
exports["default"] = _default;